SystemOrganization addCategory: #'Magritte-Seaside-Components'!
SystemOrganization addCategory: #'Magritte-Seaside-Renderer'!
SystemOrganization addCategory: #'Magritte-Seaside-Examples'!

!MAContainer class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 10:34'!
defaultComponentClass
	^MAContainerComponent! !

!MAContainer methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 21:09'!
acceptRenderer: aRenderer
	aRenderer renderContainer: self.! !

Error subclass: #MAValidationError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MAValidationError methodsFor: 'testing' stamp: 'lr 3/11/2005 17:15'!
isResumable
	^true! !

Object subclass: #MARenderer
	instanceVariableNames: 'html component readonly'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Renderer'!

MARenderer subclass: #MACssRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Renderer'!

!MACssRenderer methodsFor: 'rendering' stamp: 'lr 3/10/2005 21:51'!
renderContainer: aDescription
	html divClass: 'container' with: [ super renderContainer: aDescription ].! !

!MACssRenderer methodsFor: 'rendering-parts' stamp: 'lr 3/10/2005 21:24'!
renderEditor: aDescription
	html divClass: 'editor' with: [ super renderEditor: aDescription ].! !

!MACssRenderer methodsFor: 'rendering' stamp: 'lr 3/10/2005 21:52'!
renderElement: aDescription
	html divClass: 'element' with: [ super renderElement: aDescription ].! !

!MACssRenderer methodsFor: 'rendering-parts' stamp: 'lr 3/10/2005 21:24'!
renderLabel: aDescription
	html divClass: 'label' with: [ super renderLabel: aDescription ].
! !

!MACssRenderer methodsFor: 'rendering-parts' stamp: 'lr 3/10/2005 21:24'!
renderViewer: aDescription
	html divClass: 'viewer' with: [ super renderViewer: aDescription ].! !

!MARenderer class methodsFor: 'instance creation' stamp: 'lr 3/10/2005 21:02'!
in: aComponent on: aRenderer
	^self new
		component: aComponent;
		html: aRenderer;
		yourself.! !

!MARenderer methodsFor: 'accessing' stamp: 'lr 3/10/2005 21:02'!
component
	^component! !

!MARenderer methodsFor: 'accessing' stamp: 'lr 3/10/2005 21:02'!
component: aComponent
	component := aComponent! !

!MARenderer methodsFor: 'accessing' stamp: 'lr 3/10/2005 21:02'!
html
	^html! !

!MARenderer methodsFor: 'accessing' stamp: 'lr 3/10/2005 21:02'!
html: aRenderer
	html := aRenderer! !

!MARenderer methodsFor: 'initialize-release' stamp: 'lr 3/10/2005 22:13'!
initialize
	super initialize.
	self readonly: false.! !

!MARenderer methodsFor: 'testing' stamp: 'lr 3/10/2005 21:18'!
isReadonly
	^self readonly.! !

!MARenderer methodsFor: 'accessing' stamp: 'lr 3/10/2005 21:17'!
readonly
	^readonly! !

!MARenderer methodsFor: 'accessing' stamp: 'lr 3/10/2005 21:17'!
readonly: aBoolean
	readonly := aBoolean! !

!MARenderer methodsFor: 'rendering' stamp: 'lr 3/10/2005 21:50'!
renderContainer: aDescription
	self renderWidget: aDescription.! !

!MARenderer methodsFor: 'rendering-parts' stamp: 'lr 3/10/2005 21:17'!
renderEditor: aDescription
	self component renderEditorOn: html.! !

!MARenderer methodsFor: 'rendering' stamp: 'lr 3/10/2005 21:50'!
renderElement: aDescription
	self renderLabel: aDescription.
	self renderWidget: aDescription.! !

!MARenderer methodsFor: 'rendering-parts' stamp: 'lr 3/10/2005 21:17'!
renderLabel: aDescription
	self component renderLabelOn: html.! !

!MARenderer methodsFor: 'rendering-parts' stamp: 'lr 3/10/2005 21:17'!
renderViewer: aDescription
	self component renderViewerOn: html.! !

!MARenderer methodsFor: 'rendering-parts' stamp: 'lr 3/10/2005 21:51'!
renderWidget: aDescription
	(self isReadonly or: [ aDescription isReadonly ])
		ifTrue: [ self renderViewer: aDescription ]
		ifFalse: [ self renderEditor: aDescription ].! !

!MARenderer methodsFor: 'visiting' stamp: 'lr 3/10/2005 22:12'!
visit: aDescription
	aDescription acceptRenderer: self.! !

MARenderer subclass: #MATableRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Renderer'!

!MATableRenderer methodsFor: 'rendering' stamp: 'lr 3/10/2005 21:55'!
renderContainer: aDescription
	html table: [ super renderWidget: aDescription ].
! !

!MATableRenderer methodsFor: 'rendering' stamp: 'lr 3/10/2005 21:28'!
renderElement: aDescription
	html tableRow: [ super renderElement: aDescription ].
! !

!MATableRenderer methodsFor: 'rendering-parts' stamp: 'lr 3/10/2005 21:22'!
renderLabel: aDescription
	html tableHeading: [ super renderLabel: aDescription ].! !

!MATableRenderer methodsFor: 'rendering-parts' stamp: 'lr 3/10/2005 21:30'!
renderWidget: aDescription
	html tableData: [ super renderWidget: aDescription ].! !

!Object methodsFor: '*Magritte-Seaside' stamp: 'lr 3/9/2005 22:25'!
asComponent
	"Return a generic Seaside component of the receiver."

	^self description asComponentOn: self.! !

WAComponent subclass: #MAComponent
	instanceVariableNames: 'model description renderer'
	classVariableNames: 'Sentinel'
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MAComponent class methodsFor: 'accessing-defaults' stamp: 'lr 3/11/2005 09:15'!
defaultRenderer
	^MACssRenderer new! !

!MAComponent class methodsFor: 'class initialization' stamp: 'lr 3/11/2005 15:49'!
initialize
	Sentinel := Object new.! !

!MAComponent class methodsFor: 'instance creation' stamp: 'lr 11/28/2004 19:10'!
model: aModel
	^self model: aModel description: aModel description.! !

!MAComponent class methodsFor: 'instance creation' stamp: 'lr 12/20/2004 20:20'!
model: aModel description: aDescription
	^self model: aModel description: aDescription renderer: self defaultRenderer.! !

!MAComponent class methodsFor: 'instance creation' stamp: 'lr 12/20/2004 18:25'!
model: aModel description: aDescription renderer: aRenderer
	^self new
		model: aModel;
		description: aDescription;
		renderer: aRenderer;
		yourself.! !

!MAComponent methodsFor: 'forms' stamp: 'lr 2/28/2005 16:14'!
addForm
	self addForm: #( save cancel ).! !

!MAComponent methodsFor: 'forms' stamp: 'lr 2/28/2005 16:14'!
addForm: aCollection
	self addDecoration: (WAFormDecoration new 
		buttons: aCollection;
		yourself).! !

!MAComponent methodsFor: 'forms' stamp: 'lr 3/11/2005 17:07'!
addValidation
	self addDecoration: MAValidationDecoration new.! !

!MAComponent methodsFor: 'private' stamp: 'lr 3/10/2005 22:08'!
buildComponent: anObject
	^self 
		buildComponent: anObject 
		description: anObject description.! !

!MAComponent methodsFor: 'private' stamp: 'lr 3/10/2005 22:27'!
buildComponent: anObject description: aDescription
	^(aDescription asComponentOn: anObject)
		renderer: self renderer;
		yourself.! !

!MAComponent methodsFor: 'actions' stamp: 'lr 2/28/2005 16:14'!
cancel
	self answer: nil.! !

!MAComponent methodsFor: 'actions' stamp: 'lr 3/11/2005 11:46'!
close
	self cancel.! !

!MAComponent methodsFor: 'actions' stamp: 'lr 3/11/2005 15:44'!
commit! !

!MAComponent methodsFor: 'accessing' stamp: 'lr 2/28/2005 16:14'!
description
	^description! !

!MAComponent methodsFor: 'accessing' stamp: 'lr 2/28/2005 16:14'!
description: anObject
	description := anObject! !

!MAComponent methodsFor: 'private' stamp: 'lr 3/11/2005 16:50'!
error: aString
	MAValidationError new
		tag: self;
		signal: aString.! !

!MAComponent methodsFor: 'accessing' stamp: 'lr 2/28/2005 16:14'!
model
	^model! !

!MAComponent methodsFor: 'accessing' stamp: 'lr 2/28/2005 16:14'!
model: anObject
	model := anObject! !

!MAComponent methodsFor: 'accessing' stamp: 'lr 3/11/2005 20:40'!
readonly
	^self renderer readonly.! !

!MAComponent methodsFor: 'accessing' stamp: 'lr 3/10/2005 23:00'!
readonly: aBoolean
	self renderer readonly: aBoolean.! !

!MAComponent methodsFor: 'actions' stamp: 'lr 2/28/2005 16:14'!
refresh! !

!MAComponent methodsFor: 'rendering' stamp: 'lr 3/10/2005 22:13'!
renderContentOn: html
	self renderer
		component: self;
		html: html;
		visit: self description.! !

!MAComponent methodsFor: 'rendering-parts' stamp: 'lr 3/10/2005 22:29'!
renderEditorOn: html 
	self renderViewerOn: html.! !

!MAComponent methodsFor: 'rendering-parts' stamp: 'lr 2/28/2005 16:14'!
renderLabelOn: html
	self description label isEmptyOrNil
		ifFalse: [ html render: self description label; text: ':' ].! !

!MAComponent methodsFor: 'rendering-parts' stamp: 'lr 3/3/2005 15:18'!
renderViewerOn: html 
	html render: self cache.! !

!MAComponent methodsFor: 'accessing' stamp: 'lr 3/3/2005 16:16'!
renderer
	^renderer! !

!MAComponent methodsFor: 'accessing' stamp: 'lr 3/10/2005 22:08'!
renderer: aRenderer
	renderer := aRenderer! !

!MAComponent methodsFor: 'actions' stamp: 'lr 3/9/2005 22:22'!
reset! !

!MAComponent methodsFor: 'actions' stamp: 'lr 3/11/2005 15:44'!
save
	self validate; commit; answer: self model.! !

!MAComponent methodsFor: 'actions' stamp: 'lr 3/9/2005 22:22'!
validate! !

MAComponent subclass: #MAContainerComponent
	instanceVariableNames: 'children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MAContainerComponent methodsFor: 'private' stamp: 'lr 3/10/2005 22:32'!
buildChildren
	^Array streamContents: [ :stream |
		self description do: [ :each |
			each isVisible ifTrue: [
				stream nextPut: (self
					buildComponent: self model 
					description: each) ] ] ].! !

!MAContainerComponent methodsFor: 'accessing' stamp: 'lr 3/10/2005 22:31'!
children
	children isNil
		ifTrue: [ self children: self buildChildren ].
	^children.! !

!MAContainerComponent methodsFor: 'accessing' stamp: 'lr 3/10/2005 22:06'!
children: aCollection
	children := aCollection! !

!MAContainerComponent methodsFor: 'actions' stamp: 'lr 3/10/2005 21:59'!
commit
	super commit.
	self children do: [ :each | each commit ].! !

!MAContainerComponent methodsFor: 'actions' stamp: 'lr 3/10/2005 22:06'!
refresh
	super refresh.
	self children: nil.! !

!MAContainerComponent methodsFor: 'rendering' stamp: 'lr 3/10/2005 22:48'!
renderViewerOn: html 
	self children do: [ :each | html render: each ].! !

!MAContainerComponent methodsFor: 'actions' stamp: 'lr 3/10/2005 22:02'!
reset
	super reset.
	self children do: [ :each | each reset ].
! !

!MAContainerComponent methodsFor: 'actions' stamp: 'lr 3/10/2005 22:02'!
validate
	super validate.
	self children do: [ :each | each validate ].! !

MAComponent subclass: #MAElementComponent
	instanceVariableNames: 'cache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

MAElementComponent subclass: #MACheckboxComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MACheckboxComponent methodsFor: 'rendering' stamp: 'lr 3/10/2005 22:47'!
renderEditorOn: html
	html label: [
		html checkboxOn: #cache of: self. 
		html render: self description label ].! !

!MACheckboxComponent methodsFor: 'rendering' stamp: 'lr 3/10/2005 23:07'!
renderLabelOn: html! !

MAElementComponent subclass: #MADateInputComponent
	instanceVariableNames: 'month day year'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MADateInputComponent methodsFor: 'actions' stamp: 'lr 3/11/2005 16:02'!
commit
	self cache: (self isUndefined 
		ifTrue: [ nil ]
		ifFalse: [ Date 
			year: self year asNumber 
			month: self month asNumber 
			day: self day asNumber ]).
	super commit.! !

!MADateInputComponent methodsFor: 'accessing' stamp: 'lr 3/11/2005 15:21'!
day	
	day	 isNil ifTrue: [ 
		self day: (self cache isNil 
			ifFalse: [ self cache dayOfMonth ]) ].
	^day.! !

!MADateInputComponent methodsFor: 'accessing' stamp: 'lr 3/11/2005 16:03'!
day: anObject
	day := anObject isNil
		ifTrue: [ String new ]
		ifFalse: [ anObject asString ].! !

!MADateInputComponent methodsFor: 'testing' stamp: 'lr 3/11/2005 16:10'!
isUndefined
	^self day isEmptyOrNil
		and: [ self month isZero ]
		and: [ self year isEmptyOrNil ].! !

!MADateInputComponent methodsFor: 'accessing' stamp: 'lr 3/11/2005 16:09'!
month	
	month isNil ifTrue: [ 
		self month: (self cache isNil
			ifTrue: [ 0 ]
			ifFalse: [ self cache monthIndex ]) ].
	^month.! !

!MADateInputComponent methodsFor: 'accessing' stamp: 'lr 3/11/2005 15:34'!
month: anObject
	month := anObject! !

!MADateInputComponent methodsFor: 'rendering' stamp: 'lr 3/11/2005 15:07'!
renderDayOn: html
	html attributes: self description attributes.
	html
		textInputWithValue: self day
		callback: [ :value | self day: value ]
		maxLength: 2.
	html space.! !

!MADateInputComponent methodsFor: 'rendering' stamp: 'lr 3/11/2005 16:42'!
renderEditorOn: html
	self renderMonthOn: html.
	self renderDayOn: html.
	self renderYearOn: html.! !

!MADateInputComponent methodsFor: 'rendering' stamp: 'lr 3/11/2005 16:08'!
renderMonthOn: html
	html attributes: self description attributes.
	html
		selectFromList: (0 to: 12)
		selected: self month
		callback: [ :value | self month: value ]
		labels: [ :value | 
			value isZero
				ifTrue: [ String new ]
				ifFalse: [ Date nameOfMonth: value ] ].
	html space.! !

!MADateInputComponent methodsFor: 'rendering' stamp: 'lr 3/11/2005 15:07'!
renderYearOn: html
	html attributes: self description attributes.
	html
		textInputWithValue: self year
		callback: [ :value | self year: value ]
		maxLength: 4.
	html space.! !

!MADateInputComponent methodsFor: 'actions' stamp: 'lr 3/11/2005 16:10'!
validate
	super validate.
	self isUndefined ifFalse: [
		(self year notEmpty and: [ self year isAllDigits ])
			ifFalse: [ self error: 'Invalid year.' ].
		(self month isZero)
			ifTrue: [ self error: 'Invalid month.' ].
		(self day isAllDigits 
			and: [ self day asNumber between: 1 and: (Date daysInMonth: self month forYear: self year asNumber) ])
			ifFalse: [ self error: 'Invalid day.' ] ].! !

!MADateInputComponent methodsFor: 'accessing' stamp: 'lr 3/11/2005 15:22'!
year	
	year isNil ifTrue: [ 
		self year: (self cache isNil
			ifFalse: [ self cache year ]) ].
	^year.! !

!MADateInputComponent methodsFor: 'accessing' stamp: 'lr 3/11/2005 16:03'!
year: anObject
	year := anObject isNil
		ifTrue: [ String new ]
		ifFalse: [ anObject asString ].! !

!MAElementComponent methodsFor: 'private' stamp: 'lr 3/10/2005 22:40'!
buildCache
	^self description read: self model.! !

!MAElementComponent methodsFor: 'accessing' stamp: 'lr 3/11/2005 15:56'!
cache
	self isSentinelInCache
		ifTrue: [ self cache: self buildCache ].
	^cache.! !

!MAElementComponent methodsFor: 'accessing' stamp: 'lr 3/9/2005 22:20'!
cache: anObject
	cache := anObject! !

!MAElementComponent methodsFor: 'actions' stamp: 'lr 3/10/2005 12:04'!
commit
	super commit.
	self description isReadonly 
		ifTrue: [ ^self ].
	self description 
		write: self cache
		to: self model.! !

!MAElementComponent methodsFor: 'initialization' stamp: 'lr 3/11/2005 15:51'!
initialize
	super initialize.
	self cache: Sentinel.! !

!MAElementComponent methodsFor: 'testing' stamp: 'lr 3/11/2005 15:56'!
isSentinelInCache
	^cache == Sentinel.! !

!MAElementComponent methodsFor: 'actions' stamp: 'lr 3/11/2005 15:57'!
reset
	super reset.
	self cache: Sentinel.! !

!MAElementComponent methodsFor: 'actions' stamp: 'lr 3/9/2005 22:22'!
validate
	super validate.
	self description coerce: self cache.! !

MAElementComponent subclass: #MAFileUploadComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MAFileUploadComponent methodsFor: 'rendering' stamp: 'lr 3/9/2005 22:15'!
renderEditorOn: html 
	html attributes: self description attributes.
	html fileUploadWithCallback: [ :file | self cache: file ].! !

MAElementComponent subclass: #MAOptionsComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MAOptionsComponent methodsFor: 'rendering' stamp: 'lr 3/11/2005 20:49'!
renderEditorOn: html
	self 
		renderList: (self description isRequired
			ifTrue: [ self description options ]
			ifFalse: [ (Array with: nil) , self description options asArray ])
		selected: self cache
		callback: [ :value | self cache: value ]
		labels: self description labelBlock
		on: html.! !

!MAOptionsComponent methodsFor: 'rendering' stamp: 'lr 3/9/2005 21:59'!
renderList: aCollection selected: anObject callback: aCallbackBlock labels: aLabelBlock on: html
	self subclassResponsibility.! !

!MAOptionsComponent methodsFor: 'rendering' stamp: 'lr 3/10/2005 23:05'!
renderViewerOn: html
	html render: (self description labelBlock value: self cache).! !

MAOptionsComponent subclass: #MARadioGroupComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MARadioGroupComponent methodsFor: 'rendering' stamp: 'lr 3/10/2005 22:35'!
renderList: aCollection selected: anObject callback: aCallbackBlock labels: aLabelBlock on: html
	html radioGroup in: [ :group |
		aCollection do: [ :each |
			html label: [
				html attributes: self description attributes.
				html 
					radioButtonInGroup: group
					selected: each = anObject
					callback: [ aCallbackBlock value: each ].
				html render: (aLabelBlock value: each) ] ] ].! !

MAOptionsComponent subclass: #MASelectListComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MASelectListComponent methodsFor: 'rendering' stamp: 'lr 3/9/2005 22:15'!
renderList: aCollection selected: anObject callback: aCallbackBlock labels: aLabelBlock on: html
	html attributes: self description attributes.
	html 
		selectFromList: aCollection
		selected: anObject
		callback: aCallbackBlock
		labels: aLabelBlock.! !

MAElementComponent subclass: #MATextAreaComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MATextAreaComponent methodsFor: 'rendering' stamp: 'lr 3/9/2005 22:17'!
renderEditorOn: html 
	html attributes: self description attributes.
	html textAreaOn: #cache of: self.! !

MAElementComponent subclass: #MATextInputComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MATextInputComponent methodsFor: 'rendering' stamp: 'lr 3/10/2005 22:33'!
renderEditorOn: html 
	html attributes: self description attributes.
	html textInputOn: #cache of: self.! !

MAElementComponent subclass: #MATextPasswordComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MATextPasswordComponent methodsFor: 'actions' stamp: 'lr 3/10/2005 23:27'!
commit
	(self cache allSatisfy: [ :each | each = $* ])
		ifFalse: [ super commit ].! !

!MATextPasswordComponent methodsFor: 'accessing' stamp: 'lr 3/11/2005 16:27'!
obfuscated
	^String 
		new: (self cache isNil 
			ifTrue: [ 0 ]
			ifFalse: [ self cache size ])
		withAll: $*.! !

!MATextPasswordComponent methodsFor: 'rendering' stamp: 'lr 3/10/2005 23:25'!
renderEditorOn: html 
	html attributes: self description attributes.
	html 
		passwordInputWithValue: self obfuscated
		callback: (MessageSend 
			receiver: self 
			selector: #cache:).! !

!MATextPasswordComponent methodsFor: 'rendering' stamp: 'lr 3/10/2005 23:24'!
renderViewerOn: html 
	html render: self obfuscated.! !

MAElementComponent subclass: #MATimeInputComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MATimeInputComponent methodsFor: 'rendering' stamp: 'lr 3/10/2005 22:58'!
renderEditorOn: html
	html attributes: self description attributes.
	html 
		timeInputWithValue: self cache 
		callback: (MessageSend 
			receiver: self 
			selector: #cache:).! !

WAComponent subclass: #MAMockComponent
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Examples'!

!MAMockComponent class methodsFor: 'class initialization' stamp: 'lr 3/10/2005 15:12'!
initialize
	self registerAsApplication: 'magritte'.! !

!MAMockComponent methodsFor: 'accessing' stamp: 'lr 3/10/2005 15:02'!
model
	model isNil
		ifTrue: [ self model: MAMockModel new ].
	^model.! !

!MAMockComponent methodsFor: 'accessing' stamp: 'lr 3/10/2005 15:02'!
model: aModel
	model := aModel! !

!MAMockComponent methodsFor: 'rendering' stamp: 'lr 3/10/2005 23:01'!
renderContentOn: html
	html 
		anchorWithCallback: [ self call: self model asComponent addForm ]
		do: 'show form'.
	html text: ' '.
	html
		anchorWithCallback: [ self call: (self model asComponent 
			readonly: true; addForm; yourself) ]
		do: 'show view'.  
	html layoutTable: [
		html tableRow: [
			html tableHeading: 'Key'.
			html tableHeading: 'Label'.
			html tableHeading: 'Priority'.
			html tableHeading: 'Default'.
			html tableHeading: 'Visibility'.
			html tableHeading: 'Readonly'.
			html tableHeading: nil ].
		self model description do: [ :each |
			html tableRow: [
				html tableData: each key.
				html tableData: each label.
				html tableData: each priority.
				html tableData: each default.
				html tableData: each visible.
				html tableData: each readonly.
				html tableData: [
					html 
						anchorWithAction: [ self call: each asComponent addForm ]
						do: 'edit' ] ] ] ].! !

!MABoolean class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 22:45'!
defaultComponentClass
	^MACheckboxComponent! !

!MATime class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 10:37'!
defaultComponentClass
	^MATimeInputComponent! !

!MABinary class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 10:35'!
defaultComponentClass
	^MAFileUploadComponent! !

!MAElement class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 10:31'!
defaultAttributes
	^Dictionary new.! !

!MAElement methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 21:10'!
acceptRenderer: aRenderer
	aRenderer renderElement: self.! !

!MAElement methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 10:32'!
attributes
	^self 
		propertyAt: #attributes 
		ifAbsent: [ self class defaultAttributes ].! !

!MAElement methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 10:33'!
attributes: aDictionary
	^self propertyAt: #attributes put: aDictionary.! !

!MANumber class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 10:36'!
defaultComponentClass
	^MATextInputComponent! !

!MADate class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 10:36'!
defaultComponentClass
	^MADateInputComponent! !

!MAPassword class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 10:37'!
defaultComponentClass
	^MATextPasswordComponent! !

!MADescription class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 22:25'!
defaultComponentClass
	self subclassResponsibility! !

!MADescription methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 21:05'!
acceptRenderer: aRenderer
	self subclassResponsibility.! !

!MADescription methodsFor: '*Magritte-Seaside' stamp: 'lr 3/9/2005 22:28'!
asComponentOn: anObject
	^self componentClass model: anObject description: self.! !

!MADescription methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 10:33'!
componentClass
	^self propertyAt: #componentClass ifAbsent: [ self class defaultComponentClass ].! !

!MADescription methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 10:33'!
componentClass: aClass
	^self propertyAt: #componentClass put: aClass.! !

!MASelection class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 10:36'!
defaultComponentClass
	^MASelectListComponent! !

!MAString class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 10:36'!
defaultComponentClass
	^MATextInputComponent! !

WADecoration subclass: #MAValidationDecoration
	instanceVariableNames: 'exceptions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MAValidationDecoration methodsFor: 'accessing' stamp: 'lr 3/11/2005 17:17'!
exceptions
	exceptions isNil	
		ifTrue: [ self exceptions: OrderedCollection new ].
	^exceptions! !

!MAValidationDecoration methodsFor: 'accessing' stamp: 'lr 3/11/2005 17:17'!
exceptions: aCollection
	exceptions := aCollection! !

!MAValidationDecoration methodsFor: 'private' stamp: 'lr 3/11/2005 17:23'!
handleAnswer: anObject continueWith: aBlock
	self hasExceptions 
		ifFalse: [ super handleAnswer: anObject continueWith: aBlock ].! !

!MAValidationDecoration methodsFor: 'testing' stamp: 'lr 3/11/2005 17:17'!
hasExceptions
	^self exceptions notEmpty.! !

!MAValidationDecoration methodsFor: 'private' stamp: 'lr 3/11/2005 17:05'!
processChildCallbacks: aStream
	self wrapInHandlerDo: [ super processChildCallbacks: aStream ].! !

!MAValidationDecoration methodsFor: 'rendering' stamp: 'lr 3/11/2005 17:18'!
renderContentOn: html
	self hasExceptions
		ifTrue: [ self renderExceptionsOn: html ].
	self renderOwnerOn: html.! !

!MAValidationDecoration methodsFor: 'rendering' stamp: 'lr 3/11/2005 17:19'!
renderExceptionsOn: html
	html divClass: 'exceptions' with: [
		self exceptions do: [ :each |
			html divClass: 'exception' with: [
				html render: each tag description label; text: ': '.
				html render: each messageText ] ] ].! !

!MAValidationDecoration methodsFor: 'private' stamp: 'lr 3/11/2005 17:21'!
wrapInHandlerDo: aBlock
	"self exceptions: nil."
	^aBlock
		on: MAValidationError
		do: [ :error | 
			self exceptions add: error.
			error resume ].! !

!MAText class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 10:37'!
defaultComponentClass
	^MATextAreaComponent! !
MAComponent initialize!
MAMockComponent initialize!
